From reloc Require Export reloc lib.list.

Definition MS_nilv := NONEV.
Definition MS_consv x nOut : val := SOMEV ((SOMEV x), nOut).

Definition MS_nil := NONE.
Definition MS_cons x nOut := SOME ((SOME x), nOut).

(* Get the value of a some and spin if the argument is a none. *)
Definition getValue : val :=
  λ: "x", match: "x" with
            NONE => rec: "spin" <> := "spin" #()
          | SOME "v" => "v"
          end.

Definition MS_dequeue_variant : val :=
  λ: "toSent", rec: "try" <> :=
    let: "sent" := !"toSent" in
    let: "c" := getValue ( !"sent") in
    match: !(!(Snd "c")) with
      NONE => NONE
    | SOME "n'" =>
        if: (CAS "toSent" "sent" (! (Snd "c")))
        then SOME (getValue (Fst ("n'")))
        else "try" #()
    end.

Definition MS_enqueue_variant : val :=
  λ: "toTail" "x",
    let: "n" := ref (MS_cons "x" (ref (ref MS_nil))) in
    let: "tail" := !"toTail" in
    (rec: "try" "c" :=
      let: "t" := ! "c" in
      match: ! "t" with
        NONE =>
          (* The tail is nil, we can try to insert *)
          if: (CAS "c" "t" "n")
          then (* Insertion succeeded, update tail *)
            CAS "toTail" "tail" "n" ;; #()
          else (* Insertion failed, we try again*)
            "try" "c"
      | SOME "c'" => "try" (Snd "c'")
      end
    ) (Snd (getValue !"tail")).

Definition MS_queue_variant : val :=
  Λ: let: "node" := ref (SOME (NONE, ref (ref NONE))) in
     let: "toTail" := ref "node" in
     let: "toSent" := ref "node" in
     (MS_dequeue_variant "toSent", MS_enqueue_variant "toTail").
