# Contextual refinement of the Michael Scott queue

The Michael-Scott queue (MS-queue) is a fast and practical concurrent queue.

In this example we prove that both the original MS-queue, and variant of it, is
a contextual refinement of a queue implemented using course grained concurrency.
The variant of the MS-queue closely resembles `ConcurrentLinkedQueue` in the
Java standard library `java.util.concurrent`.

For a more detailed description of the queue and the proofs see the notes [Proof
of Contextual Refinement of Michael-Scott Queue using Logical Relations in
Iris](FIXME INSERT LINK TO NOTES).

## Iris with persistent points-to

The directory `iris` contains our fork of Iris with the following additions and
changes:

- We have implemented the two resource algebras described in the paper.
  The discardable fractions resource algebra is in `iris/..../FIXME`.
  The fractions 

## Overview over files

- `MS_queue`: Contains the HeapLang implementation of the original unchanged
  MS-queue.
- `MS_queue_no_snapshot.v`: Contains the HeapLang implementation of the MS-queue
  with the atomic snapshots removed.