From Coq.Lists Require Import List.
From iris.algebra Require Import numbers csum excl auth list gmap.
From iris.program_logic Require Import adequacy ectxi_language.

From iris.proofmode Require Import tactics.
From reloc Require Import reloc lib.lock.

(* Repeatedly introduce existential variables. *)
Ltac iExistsN := repeat iExists _.

(* A handy tactic for brute forcing some goals. Solve a goal that consists of
   introducing existentials, framing, and picking branches. *)
Ltac iExistsFrame :=
  (repeat iExistsN || iFrame || iFrame "#");
  (done || (iLeft; iExistsFrame) || (iRight; iExistsFrame) || fail "Could not solve goal").
